//
//  Utilities.h
//  oneBuddy
//

#ifndef oneBuddy_Utilities_h
#define oneBuddy_Utilities_h
#include <cassert>
#include <cctype>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <iosfwd>
#include <fstream>
#include <string>
#include <sstream>
#include <limits>
#include <math.h>
#include <complex>
#include <sys/stat.h>
#define MAX_LENGHT std::numeric_limits<std::streamsize>::max()
using namespace std;

#ifndef SMALL_VALUE
#define SMALL_VALUE  double(10e-14)
#endif


// NUMBER UTILITIES
bool dbEqual(const double &a, const double &b) {
    return abs(a - b) < 0.00000000001;
}

int gcd(const int &m, const int &n) { //greater common divisor
    if(n == 0)
        return m;
    else
        return gcd(n, m % n);
}

int lcm(const int &m, const int &n) {  //least common multiple
    return m*n/gcd(m,n);
}


int posMod(int a, int b) {
    return a%b+b*(a%b<0);
}

int floorDiv(int a, int b) {
    return (a - (a<0 ? b-1 : 0)) / b;
}


// FILES UTILITIES
inline bool exists(const string &name) {
    struct stat buffer;
    return (stat (name.c_str(), &buffer) == 0);
}

void nextLine(istream &flux) {
    flux.ignore(MAX_LENGHT,'\n');
}

void reset(istream &flux){
    flux.clear();
    flux.seekg(0);
}

bool reach(istream &flux, const string &search) {
    string buff;
    while (flux.peek() != EOF)
    {
        flux >> buff;
        if(buff.compare(search)==0){
            return true;
        }
        nextLine(flux);
    }
    return false;
}

bool is_number(const string& s) {
    return !s.empty() && s.find_first_not_of("-0123456789.e") == string::npos;
}

bool is_uint(const string& s) {
    return !s.empty() && s.find_first_not_of("0123456789") == string::npos;
}


#endif
