//
//  butterfly.h
//  oneBuddy
//
//  Created by Simon Verret on 2016-10-29.
//  Copyright (c) 2016 Simon Verret. All rights reserved.
//

#ifndef oneBuddy_butterfly_h
#define oneBuddy_butterfly_h
#include "build.h"

static vector<double> b_eigenValues;
static HmMatrix<complex<double>> b_eigenVectors;
static HmMatrix<complex<double>> b_hamiltonian;

void butterfly(ParameterSet &p){
    
    //string parameter("Bx");
    //PlaneVector startQ(1,4,0,1);
    //PlaneVector endQ(1,2,0,1);
    //int Denom = 1000;
    
    //int start_py=0;
    //int end_py=0;
    
    cout << "printing eigenvalues vs wave-vector of parameter " << p.butt_parameter << endl;
    ofstream outputFile;
    outputFile.open(p.butt_filename);
    
    p.butt_startQ.forceDenomX(p.butt_Denom);
    p.butt_endQ.forceDenomX(p.butt_Denom);
    for (int q = p.butt_startQ.xNum; q < (p.butt_endQ.xNum+1); q++) {
        PlaneVector newQ(q,p.butt_Denom,0,1);
        
        for (auto& term : p.termList){
            if (term.identifier == p.butt_parameter)
            for (auto& element : term.elementList){
                element.waveVector = newQ;
            }
        }
        
        p.reduce();
        p.selfUpdate();
        b_eigenValues.resize(p.dim);
        b_eigenVectors.resize(p.dim);
        b_hamiltonian.resize(p.dim);
        if(p.verbose >= 1) {
            cout << '\r';
            cout << "q/N=" << q << "/" << p.butt_Denom << "   ";
            cout << "dim=" << p.dim << "   ";
            cout << int( (q-p.butt_startQ.xNum) /(double)( p.butt_endQ.xNum-p.butt_startQ.xNum )*100) << "% done";
            cout << flush;
        }
        
        // //// best Hofstadter Butterfly, but mingle other spectrums
        // int ResY = N/p.Lx;
        // int ResX = sqrt(ResY);
        // //// only at one
        int ResX = p.butt_Denom/p.Lx; // equivalent to a Denom x Denom matrix, but with smallest possible matrix.
        //int ResY = 50;
        //for (int py=start_py; py < end_py+1; py++){
            for (int px=0; px < ResX; px ++) {
                double pxc = px/(double)ResX + p.butt_pxcOff;
                //double pyc = py/(double)ResY;
                
                buildHamiltonianInPlace(b_hamiltonian,p,pxc, p.butt_pyc ,0,0);
                diagonalize(b_hamiltonian, b_eigenVectors, b_eigenValues);
                for (auto& value : b_eigenValues){
                    outputFile << q << "\t";
                    outputFile << value << "\t";
                    outputFile << endl;
                }
            }
        //}
    }
    outputFile.close();
    cout << endl << "printed butterfly.out" << endl;
}


#endif
